Merge branch 'mt/p4-depotFile-at-version'
[git.git] / git-pull.sh
blob0917d0d056573912df60afd7b556efe04eeebae8
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
9 SUBDIRECTORY_OK=Yes
10 OPTIONS_SPEC=
11 . git-sh-setup
12 . git-sh-i18n
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
15 cd_to_toplevel
18 die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution and make a commit.")"
24 else
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
29 die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
33 else
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 bool_or_string_config () {
42 git config --bool "$1" 2>/dev/null || git config "$1"
45 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
46 log_arg= verbosity= progress= recurse_submodules= verify_signatures=
47 merge_args= edit= rebase_args=
48 curr_branch=$(git symbolic-ref -q HEAD)
49 curr_branch_short="${curr_branch#refs/heads/}"
50 rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
51 if test -z "$rebase"
52 then
53 rebase=$(bool_or_string_config pull.rebase)
56 # Setup default fast-forward options via `pull.ff`
57 pull_ff=$(bool_or_string_config pull.ff)
58 case "$pull_ff" in
59 true)
60 no_ff=--ff
62 false)
63 no_ff=--no-ff
65 only)
66 ff_only=--ff-only
68 esac
71 dry_run=
72 while :
74 case "$1" in
75 -q|--quiet)
76 verbosity="$verbosity -q" ;;
77 -v|--verbose)
78 verbosity="$verbosity -v" ;;
79 --progress)
80 progress=--progress ;;
81 --no-progress)
82 progress=--no-progress ;;
83 -n|--no-stat|--no-summary)
84 diffstat=--no-stat ;;
85 --stat|--summary)
86 diffstat=--stat ;;
87 --log|--log=*|--no-log)
88 log_arg="$1" ;;
89 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
90 no_commit=--no-commit ;;
91 --c|--co|--com|--comm|--commi|--commit)
92 no_commit=--commit ;;
93 -e|--edit)
94 edit=--edit ;;
95 --no-edit)
96 edit=--no-edit ;;
97 --sq|--squ|--squa|--squas|--squash)
98 squash=--squash ;;
99 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
100 squash=--no-squash ;;
101 --ff)
102 no_ff=--ff ;;
103 --no-ff)
104 no_ff=--no-ff ;;
105 --ff-only)
106 ff_only=--ff-only ;;
107 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
108 --strateg=*|--strategy=*|\
109 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
110 case "$#,$1" in
111 *,*=*)
112 strategy=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
113 1,*)
114 usage ;;
116 strategy="$2"
117 shift ;;
118 esac
119 strategy_args="${strategy_args}-s $strategy "
121 -X*)
122 case "$#,$1" in
123 1,-X)
124 usage ;;
125 *,-X)
126 xx="-X $(git rev-parse --sq-quote "$2")"
127 shift ;;
128 *,*)
129 xx=$(git rev-parse --sq-quote "$1") ;;
130 esac
131 merge_args="$merge_args$xx "
133 -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
134 rebase="${1#*=}"
136 -r|--r|--re|--reb|--reba|--rebas|--rebase)
137 rebase=true
139 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
140 rebase=false
142 --recurse-submodules)
143 recurse_submodules=--recurse-submodules
145 --recurse-submodules=*)
146 recurse_submodules="$1"
148 --no-recurse-submodules)
149 recurse_submodules=--no-recurse-submodules
151 --verify-signatures)
152 verify_signatures=--verify-signatures
154 --no-verify-signatures)
155 verify_signatures=--no-verify-signatures
157 --gpg-sign|-S)
158 gpg_sign_args=-S
160 --gpg-sign=*)
161 gpg_sign_args=$(git rev-parse --sq-quote "-S${1#--gpg-sign=}")
163 -S*)
164 gpg_sign_args=$(git rev-parse --sq-quote "$1")
166 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
167 dry_run=--dry-run
169 -h|--help-all)
170 usage
173 # Pass thru anything that may be meant for fetch.
174 break
176 esac
177 shift
178 done
180 case "$rebase" in
181 preserve)
182 rebase=true
183 rebase_args=--preserve-merges
185 true|false|'')
188 echo "Invalid value for --rebase, should be true, false, or preserve"
189 usage
190 exit 1
192 esac
194 error_on_no_merge_candidates () {
195 exec >&2
197 if test true = "$rebase"
198 then
199 op_type=rebase
200 op_prep=against
201 else
202 op_type=merge
203 op_prep=with
206 upstream=$(git config "branch.$curr_branch_short.merge")
207 remote=$(git config "branch.$curr_branch_short.remote")
209 if [ $# -gt 1 ]; then
210 if [ "$rebase" = true ]; then
211 printf "There is no candidate for rebasing against "
212 else
213 printf "There are no candidates for merging "
215 echo "among the refs that you just fetched."
216 echo "Generally this means that you provided a wildcard refspec which had no"
217 echo "matches on the remote end."
218 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
219 echo "You asked to pull from the remote '$1', but did not specify"
220 echo "a branch. Because this is not the default configured remote"
221 echo "for your current branch, you must specify a branch on the command line."
222 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
223 . git-parse-remote
224 error_on_missing_default_upstream "pull" $op_type $op_prep \
225 "git pull <remote> <branch>"
226 else
227 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
228 echo "from the remote, but no such ref was fetched."
230 exit 1
233 test true = "$rebase" && {
234 if ! git rev-parse -q --verify HEAD >/dev/null
235 then
236 # On an unborn branch
237 if test -f "$(git rev-parse --git-path index)"
238 then
239 die "$(gettext "updating an unborn branch with changes added to the index")"
241 else
242 require_clean_work_tree "pull with rebase" "Please commit or stash them."
244 oldremoteref= &&
245 test -n "$curr_branch" &&
246 . git-parse-remote &&
247 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
248 oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
250 orig_head=$(git rev-parse -q --verify HEAD)
251 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
252 test -z "$dry_run" || exit 0
254 curr_head=$(git rev-parse -q --verify HEAD)
255 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
256 then
257 # The fetch involved updating the current branch.
259 # The working tree and the index file is still based on the
260 # $orig_head commit, but we are merging into $curr_head.
261 # First update the working tree to match $curr_head.
263 eval_gettextln "Warning: fetch updated the current branch head.
264 Warning: fast-forwarding your working tree from
265 Warning: commit \$orig_head." >&2
266 git update-index -q --refresh
267 git read-tree -u -m "$orig_head" "$curr_head" ||
268 die "$(eval_gettext "Cannot fast-forward your working tree.
269 After making sure that you saved anything precious from
270 $ git diff \$orig_head
271 output, run
272 $ git reset --hard
273 to recover.")"
277 merge_head=$(sed -e '/ not-for-merge /d' \
278 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
279 tr '\012' ' ')
281 case "$merge_head" in
283 error_on_no_merge_candidates "$@"
285 ?*' '?*)
286 if test -z "$orig_head"
287 then
288 die "$(gettext "Cannot merge multiple branches into empty head")"
290 if test true = "$rebase"
291 then
292 die "$(gettext "Cannot rebase onto multiple branches")"
295 esac
297 # Pulling into unborn branch: a shorthand for branching off
298 # FETCH_HEAD, for lazy typers.
299 if test -z "$orig_head"
300 then
301 # Two-way merge: we claim the index is based on an empty tree,
302 # and try to fast-forward to HEAD. This ensures we will not
303 # lose index/worktree changes that the user already made on
304 # the unborn branch.
305 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
306 git read-tree -m -u $empty_tree $merge_head &&
307 git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
308 exit
311 if test true = "$rebase"
312 then
313 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
314 if test "$oldremoteref" = "$o"
315 then
316 unset oldremoteref
320 case "$rebase" in
321 true)
322 eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
323 eval="$eval $gpg_sign_args"
324 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
327 eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
328 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
329 eval="$eval $gpg_sign_args"
330 eval="$eval FETCH_HEAD"
332 esac
333 eval "exec $eval"